{
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev (Virtualik) 
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
   WWW    : http://chat.str.ru             
                                           
  VIRtUal Soft         All rights reserved 
 
  
}
{
 ᪨ 吝 ᯨ᮪: TList
 ন ⮤:
 [*] ⠢  / 㦥 騬
 [*]     ᯨ᪠
 [*] 祭 뫪  /᫥/᫥騩 
 [*] ஢ઠ  ⢮    祭
 [*]     ᯨ᪠
 [*]  ⮢  ᫮
 [*]  ⮢  ᯨ᪠ ᮤঠ騥 㪠 祭
 [*] ॡ ⮢ ᯨ᪠
 [*] ஢ ᯨ᪠

 ਬ.:  ⮤,   ॡ ᤥ 室 ᯨ᪠ 稭
   ᯨ᪠  த ।  ।-  ᫥-.

 ᪨  ⥪: TStack
 ন ⮤:
 [*]  
 [*] 祭  孥 
 [*] ஢ઠ  
}{$F+}
unit DynList;

interface

type
 TData = String; {   -⮢ ᯨ᪠ }

 {  ᯨ᪠ }
 PListItem = ^TListItem;
 TListItem = record
  Next,         { 騩  }
  Prev : PListItem; { ।騩  }
  Data : TData; {  }
 end;

 { ⮤  ࠡ⪨  -  樨 }
 TIterateProc = Procedure (Value: TData);
 TCompare = function (Value1, Value2: TData): ShortInt;
 TDelFunc = function (Value: TData): Boolean;

 TList = object
  private
   Start,            {  - }
   Last: PListItem;  { ᫥ - }
   Size: Word;       { ⢮ ⮢ }
  public
   constructor Initialize;   { 樠 }
   destructor Deinitialize;  { 樠 }
   procedure Create;         { 뤥  }
   procedure Destroy;        { ᢮  }
   function GetSize: Word;   { 饭 ࠧ ᯨ᪠ }
   function GetFirst: PListItem; { 饭 1- - }
   function GetLast: PListItem;  { 饭 ᫥ - }
   function GetNext(Item: PListItem): PListItem;  { 饭 ᫥饣 - }
   function Exist(Value: TData): Boolean; { ஢ઠ  - -   祭 }
   procedure AppendItem(Value: TData); {   }
   function  InsertItem(Value: TData; Item: PListItem): PListItem; { ⠢  }
   procedure DeleteItem(Item: PListItem); {    ᯨ᪠ }
   procedure DelItems(Value: TData); {    ᯨ᪠ ᮤ-騥 㪠 祭 }
   procedure DelItemsCond(CondFunc: TDelFunc); {    ᯨ᪠ 㤮⢮騥 ᫮ }
   procedure Iterate(IterateProc : TIterateProc); { ॡ ᯨ᪠ ⮢ }
   procedure Sort(Compare: TCompare);
 end;

 PStackItem = ^TStackItem;
 TStackItem = record
  Prev: PStackItem;
  Data: TData;
 end;

 TStack = object
  private
   Top: PStackItem;
  public
   constructor Initialize;   { 樠 }
   destructor Deinitialize;  { 樠 }
   procedure Create;         { 뤥  }
   procedure Destroy;        { ᢮  }
   function Empty: Boolean;
   procedure Push(Value: TData);
   function  Pop: TData;
 end;

 const
  DefData : TData = '';

implementation

{ TList }

{ 楤,  㬮砭 ᯮ  樨 }
procedure PrintItem(Value: TData);
begin
 Write(Value,' ');
end;

{ 楤 ࠢ  㬮砭 }
function DefCompare(Value1, Value2: TData): ShortInt;
begin
 if Value1>Value2 then DefCompare := 1 else DefCompare := 0;
end;

constructor TList.Initialize;
begin

end;

destructor TList.Deinitialize;
begin

end;

procedure TList.Create;
begin
 Start := nil;
 Last  := nil;
 Size  := 0;
end;

function TList.GetSize: Word;
begin
 GetSize := Size;
end;

function TList.GetFirst: PListItem;
begin
 GetFirst := Start;
end;

function TList.GetLast: PListItem;
begin
 GetLast := Last;
end;

function TList.GetNext(Item: PListItem): PListItem;
begin
 GetNext := Item^.Next;
end;

{     ᯨ᪠ }
procedure TList.AppendItem(Value: TData);
var
 NewItem: PListItem;
begin
 New(NewItem); { ।  }
 NewItem^.Data := Value; { ᢮ 祭  }
 if Start<>nil then
 begin
  {     ᯨ᪠ }
  NewItem^.Next := nil;
  NewItem^.Prev := Last;
  Last^.Next    := NewItem;
  Last          := NewItem;
 end else
 begin
  {  ࢮ  }
  NewItem^.Next := nil;
  NewItem^.Prev := nil;
  Start := NewItem;
  Last  := NewItem;
 end;
 Inc(Size);
end;

{ ⠢  }
function TList.InsertItem(Value: TData; Item: PListItem): PListItem;
var
 NewItem: PListItem;
begin
 New(NewItem);
 NewItem^.Data := Value;

 if Item<>nil then
 begin
  NewItem^.Prev := Item;
  NewItem^.Next := Item^.Next;
  Item^.Next := NewItem;
 end;

 { 뢠, ᫨ ⠢塞 -  }
 if Start = nil then
  begin
   Start := NewItem;
   Last  := NewItem;
  end;
 InsertItem := NewItem;
 Inc(Size);
end;

function TList.Exist(Value: TData): Boolean;
var
 CItem: PListItem;
begin
 Exist := False;
 CItem := Start;
 while CItem<>nil do
  begin
   { 諨 㦭  }
   if CItem^.Data = Value then
    begin
     Exist := True;
     break;
    end else CItem := CItem^.Next; { ४祭  ᫥- - }
  end;
end;

procedure TList.Iterate(IterateProc : TIterateProc);
var
 CItem: PListItem;
begin
 if not Assigned(IterateProc) then IterateProc := PrintItem;
 CItem := Start;
 while CItem<>nil do
  begin
   IterateProc(CItem^.Data);
   CItem := CItem^.Next; { ४祭  ᫥- - }
  end;
end;

procedure TList.DelItems(Value: TData);
var
 CItem, X: PListItem;
begin
 CItem := Start;
 while CItem<>nil do
 begin
  if CItem^.Data = Value then
  begin
   X := CItem;
   CItem := CItem^.Next;
   DeleteItem(X);
  end else
   CItem := CItem^.Next;
 end;
end;

procedure TList.DelItemsCond(CondFunc: TDelFunc);
var
 CItem, X: PListItem;
begin
 if not Assigned(CondFunc) then exit;
 CItem := Start;
 while CItem<>nil do
 begin
  if CondFunc(CItem^.Data) then
  begin { 塞 , ᫨ 㤮- ᫮ }
   X := CItem;
   CItem := CItem^.Next;
   DeleteItem(X);
  end else
   CItem := CItem^.Next;
 end;
end;

procedure TList.DeleteItem(Item: PListItem);
begin
 if Item <> Start then
  Item^.Prev^.Next := Item^.Next
   else Start := Item^.Next;

 if Item <> Last then
   Item^.Next^.Prev := Item^.Prev;
 Dispose(Item);
 Dec(Size);
end;

procedure TList.Destroy;
var
 CItem, X: PListItem;
begin
 { ᢮  }
 CItem := Start;
 while CItem<>nil do
 begin
  X := CItem;
  CItem := CItem^.Next;
  Dispose(X);
 end;
 Size := 0;
end;

procedure TList.Sort(Compare: TCompare);
var
 CItem,
 CItem2,
 CItem3: PListItem;
 VBuf: TData;
 i, j, k: Word;
begin
 if not Assigned(Compare) then Compare := DefCompare;
 CItem := Start^.Next;
 For I := 2 to Size do
  begin
   VBuf := CItem^.Data;

   j := 1;

   CItem2 := Start;
   while (Compare(VBuf, CItem2^.Data)=1) do
    begin
     j := j + 1;
     CItem2 := CItem2^.Next;
    end;

   CItem3 := CItem^.Next;
   CItem := CItem^.Prev;

   {饭 ᨢ}
   for k := i - 1 downto j do
   begin
    CItem^.Next^.Data := CItem^.Data;
    CItem := CItem^.Prev;
   end;

   CItem := CItem3;
   CItem2^.Data := VBuf; { ⠢  }
  end;
end;

{ TStack }

constructor TStack.Initialize;
begin

end;

destructor TStack.Deinitialize;
begin

end;

procedure TStack.Create;
begin
 Top := nil;
end;

function TStack.Empty: Boolean;
begin
 Empty := Top = nil;
end;

procedure TStack.Destroy;
begin
 while not Empty do Pop;
end;

procedure TStack.Push(Value: TData);
var
 NewItem: PStackItem;
begin
 New(NewItem);
 NewItem^.Data := Value;
 NewItem^.Prev := Top;
 Top := NewItem;
end;

function TStack.Pop: TData;
var
 P : PStackItem;
begin
 if not Empty then
  begin
   Pop := Top^.Data;
   P   := Top;
   Top := Top^.Prev;
   Dispose(P);
  end else Pop := DefData;
end;

end.